{% extends "layout.html" %}
{% block title %}Dashboard{% endblock %}
{% block section %}Dashboard{% endblock %}
{% block head %}
{{ super() }}
    <link rel="stylesheet" href="/static/bower_components/datatables.net-bs/css/dataTables.bootstrap.min.css">
{% endblock %}
{% block content %}
    <div class="row">
      <div class="col-md-3 col-sm-6 col-xs-12">
        <div class="info-box">
          <span class="info-box-icon bg-yellow"><i class="fa fa-lightbulb-o"></i></span>

          <div class="info-box-content">
            <span class="info-box-text">Lights</span>
            <span class="info-box-number"></span>
          </div>
          <!-- /.info-box-content -->
        </div>
        <!-- /.info-box -->
      </div>
      <!-- /.col -->
      <div class="col-md-3 col-sm-6 col-xs-12">
        <div class="info-box">
          <span class="info-box-icon bg-navy"><i class="fa fa-snowflake-o"></i></span>
          <div class="info-box-content">
            <span class="info-box-text">Exhaust</span>
            <span class="info-box-number"></span>
          </div>
          <!-- /.info-box-content -->
        </div>
        <!-- /.info-box -->
      </div>
      <!-- /.col -->
      <!-- fix for small devices only -->
      <div class="clearfix visible-sm-block"></div>
      <div class="col-md-3 col-sm-6 col-xs-12">
        <div class="info-box">
          <span class="info-box-icon bg-green"><i class="fa fa-refresh"></i></span>
          <div class="info-box-content">
            <span class="info-box-text">Fan</span>
            <span class="info-box-number"></span>
          </div>
          <!-- /.info-box-content -->
        </div>
        <!-- /.info-box -->
      </div>
      <!-- /.col -->
      <div class="col-md-3 col-sm-6 col-xs-12">
        <div class="info-box">
          <span class="info-box-icon bg-aqua"><i class="fa fa-shower"></i></span>
          <div class="info-box-content">
            <span class="info-box-text">Water Pump</span>
            <span class="info-box-number"></span>
          </div>
          <!-- /.info-box-content -->
        </div>
        <!-- /.info-box -->
      </div>
      <!-- /.col -->
    </div>

  <!-- /.row -->

  <!-- /.row -->
  <!-- Main row -->
  <div class="row">
    <!-- Left col -->
    <div class="col-md-6">
      <!-- /.box -->
         <!-- TABLE: Relay logs -->
        <div class="box">
          <div class="box-header with-border">
            <h3 class="box-title">Alerts</h3>
            <div class="box-tools pull-right">
              <button type="button" class="btn btn-box-tool" data-widget="collapse"><i class="fa fa-minus"></i>
              </button>
              <button type="button" class="btn btn-box-tool" data-widget="remove"><i class="fa fa-times"></i></button>
            </div>
          </div>
          <!-- /.box-header -->
          <div class="box-body">
            <div class="table-responsive">
              <table class="table no-margin">
                <thead>
                <tr>
                  <th></th>
                  <th>Last Check</th>
                  <th>Sensor</th>
                  <th>Alert</th>
                  <th>Value</th>
                  <th>Status</th>
                  <th></th>
                </tr>
                </thead>
                <tbody>
                {% for item in alerts %}
                    <tr data-record-id="{{ item.id }}">
                      <td>{{ item.id }}</td>
                      <td>{{ moment(item.last_check).format('LLL') }}</td>
                      <td>{{ item.sensor.name }}</td>
                      <td>{{ item.metric }} {{ item.operator }} {{ item.threshold }}</td>
                      <td>{{ item.reading }}</td>
                      <td>{{ item.status }}</td>
                      <td><a href="#" data-record-id="{{ item.id }}" data-record-title="{{ item.sensor }} {{ item.metric }}"
                       data-toggle="modal" data-target="#confirm-disable">close</a></td>
                    </tr>
                {% endfor %}
                </tbody>
              </table>
            </div>
            <!-- /.table-responsive -->
          </div>
          <!-- /.box-body -->
        </div>
      </div>
      <!-- /.col -->
      <div class="col-md-6">
        <div class="box">
          <div class="box-header with-border">
            <h3 class="box-title">Schedules</h3>

            <div class="box-tools pull-right">
              <button type="button" class="btn btn-box-tool" data-widget="collapse"><i class="fa fa-minus"></i>
              </button>
              <button type="button" class="btn btn-box-tool" data-widget="remove"><i class="fa fa-times"></i></button>
            </div>
          </div>
          <!-- /.box-header -->
          <div class="box-body">
            <div class="table-responsive">
              <table class="table no-margin">
                <thead>
                <tr>
                  <th></th>
                  <th>Relay</th>
                  <th>Start Time</th>
                  <th>Stop Time</th>
                  <th>Created On</th>
                  <th>Enabled</th>
                </tr>
                </thead>
                <tbody>
                {% for item in schedules %}
                <tr data-record-id="item.id">
                  <td>{{ item.id }}</td>
                  <td>{{ item.relay }}</td>
                  <td>{{ moment(item.start_time).format('HH:mm') }}</td>
                  <td>{{ moment(item.stop_time).format('HH:mm') }}</td>
                  <td>{{ moment(item.created_on).format('LLL') }}</td>
                  <td><span class="label label-success">{{ item.enabled }}</span></td>
                </tr>
                {% endfor %}
                </tbody>
              </table>
            </div>
            <!-- /.table-responsive -->
          </div>
          <!-- /.box-body -->
        </div>

      </div>
    <!-- /.col -->
  </div>
  <div class="row">
      <div class="col-md-12">
        <div class="box">
          <div class="box-header with-border">
            {% if last_reading_mijia %}
              <h3 class="box-title">Mijia Sensor {{ last_reading_mijia.sensor.name }}</h3>
            {% else %}
              <h3 class="box-title">Mijia Sensor</h3>
            {% endif %}

            <div class="box-tools pull-right">
              <button type="button" class="btn btn-box-tool" data-widget="collapse"><i class="fa fa-minus"></i>
              </button>
              <div class="btn-group">
                <button type="button" class="btn btn-box-tool dropdown-toggle" data-toggle="dropdown">
                  <i class="fa fa-wrench"></i></button>
                <ul class="dropdown-menu" role="menu">
                  <li><a href="/">Last Day</a></li>
                  <li><a href="?last=7">Last Week</a></li>
                  <li><a href="?last=30">Last Month</a></li>
                </ul>
              </div>
              <button type="button" class="btn btn-box-tool" data-widget="remove"><i class="fa fa-times"></i></button>
            </div>
          </div>
          <!-- /.box-header -->
          <div class="box-body">
            <div class="row">
              <div class="col-md-12">
                <p class="text-center">
                  <strong>Last 24 Hours</strong>
                </p>
                <div class="chart">
                  <!-- Sales Chart Canvas -->
                  <canvas id="chart-mijia" style="height: 450px;"></canvas>
                </div>
                <!-- /.chart-responsive -->
              </div>
              <!-- /.col -->
            </div>
            <!-- /.row -->
          </div>
          <!-- ./box-body -->
          <div class="box-footer">
            <div class="row">
              <div class="col-sm-4 col-xs-4">
                <div class="description-block border-right">
                  <span class="description-percentage text-red"><i></i>Temperature</span>
                  <h5 class="description-header"> {{ last_reading_mijia.temperature }} &deg;C</h5>
                </div>
                <!-- /.description-block -->
              </div>
              <!-- /.col -->
              <div class="col-sm-4 col-xs-4">
                <div class="description-block border-right">
                  <span class="description-percentage text-green"><i></i>Humidity</span>
                  <h5 class="description-header">{{ last_reading_mijia.humidity }} %</h5>
                </div>
                <!-- /.description-block -->
              </div>
              <!-- /.col -->
              <div class="col-sm-4 col-xs-4">
                <div class="description-block border-right">
                  <span class="description-percentage text-grey"><i></i>Battery</span>
                  <h5 class="description-header">{{ last_reading_mijia.battery }} %</h5>
                </div>
                <!-- /.description-block -->
              </div>
              <!-- /.col -->
            </div>
            <!-- /.row -->
          </div>
          <!-- /.box-footer -->
        </div>
        <!-- /.box -->
      </div>
    <!-- /.col -->
  </div>
  <div class="row">
      <div class="col-md-12">
        <div class="box">
          <div class="box-header with-border">
            {% if last_reading_flora  %}
              <h3 class="box-title">Flora Sensor {{ last_reading_flora.sensor.name }}</h3>
            {% else %}
              <h3 class="box-title">Flora Sensor</h3>
            {% endif %}
            <div class="box-tools pull-right">
              <button type="button" class="btn btn-box-tool" data-widget="collapse"><i class="fa fa-minus"></i>
              </button>
              <div class="btn-group">
                <button type="button" class="btn btn-box-tool dropdown-toggle" data-toggle="dropdown">
                  <i class="fa fa-wrench"></i></button>
                <ul class="dropdown-menu" role="menu">
                  <li><a href="/">Last Day</a></li>
                  <li><a href="?last=7">Last Week</a></li>
                  <li><a href="?last=30">Last Month</a></li>
                </ul>
              </div>
              <button type="button" class="btn btn-box-tool" data-widget="remove"><i class="fa fa-times"></i></button>
            </div>
          </div>
          <!-- /.box-header -->
          <div class="box-body">
            <div class="row">
              <div class="col-md-12">
                <p class="text-center">
                  <strong>Last 24 Hours</strong>
                </p>
                <div class="chart">
                  <!-- Sales Chart Canvas -->
                  <canvas id="chart-flora" style="height: 450px;"></canvas>
                </div>
                <!-- /.chart-responsive -->
              </div>
              <!-- /.col -->
            </div>
            <!-- /.row -->
          </div>
          <!-- ./box-body -->
          <div class="box-footer">
            <div class="row">
              <div class="col-sm-4 col-xs-4">
                <div class="description-block border-right">
                  <span class="description-percentage text-red"><i></i>Temperature</span>
                  <h5 class="description-header"> {{ last_reading_flora.temperature }} &deg;C</h5>
                </div>
                <!-- /.description-block -->
              </div>
              <!-- /.col -->
              <div class="col-sm-4 col-xs-4">
                <div class="description-block border-right">
                  <span class="description-percentage text-green"><i></i>Moisture</span>
                  <h5 class="description-header">{{ last_reading_flora.moisture }} %</h5>
                </div>
                <!-- /.description-block -->
              </div>
              <!-- /.col -->
              <div class="col-sm-4 col-xs-4">
                <div class="description-block border-right">
                  <span class="description-percentage text-yellow"><i></i>Light</span>
                  <h5 class="description-header">{{ last_reading_flora.light }} Lux</h5>
                </div>
                <!-- /.description-block -->
              </div>
              <!-- /.col -->
            </div>
            <div class="row">
              <div class="col-sm-6 col-xs-6">
                <div class="description-block border-right">
                  <span class="description-percentage text-blue"><i></i>Conductivity</span>
                  <h5 class="description-header"> {{ last_reading_flora.conductivity }} µS/cm</h5>
                </div>
                <!-- /.description-block -->
              </div>
              <!-- /.col -->
              <div class="col-sm-6 col-xs-6">
                <div class="description-block border-right">
                  <span class="description-percentage text-grey"><i></i>Battery</span>
                  <h5 class="description-header">{{ last_reading_flora.battery }} %</h5>
                </div>
                <!-- /.description-block -->
              </div>
              <!-- /.col -->
            </div>
            <!-- /.row -->
          </div>
          <!-- /.box-footer -->
        </div>
        <!-- /.box -->
      </div>
    <!-- /.col -->
  </div>
      <!-- /.row -->
    <div class="modal fade" id="confirm-switch-on" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title" id="myModalLabel1">Confirm Turn ON </h4>
                </div>
                <div class="modal-body">
                    <p>You are about to turn ON the <b><i class="title"></i></b> switch.</p>
                    <p>Do you want to proceed?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-success btn-ok">Turn ON</button>
                </div>
            </div>
        </div>
    </div>

      <div class="modal fade" id="confirm-switch-off" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title" id="myModalLabel2">Confirm Turn OFF</h4>
                </div>
                <div class="modal-body">
                    <p>You are about to turn OFF the <b><i class="title"></i></b> switch.</p>
                    <p>Do you want to proceed?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-danger btn-ok">Turn OFF</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="confirm-delete" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title" id="myModalLabel">Confirm Delete</h4>
                </div>
                <div class="modal-body">
                    <p>You are about to delete <b><i class="title"></i></b> this procedure is irreversible.</p>
                    <p>Do you want to proceed?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-danger btn-ok">Delete</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="confirm-disable" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title" id="myModalLabel3">Confirm Action</h4>
                </div>
                <div class="modal-body">
                    <p>You are about to close the alert for sensor <b><i class="title"></i></b>.</p>
                    <p>Do you want to proceed?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-danger btn-ok">Submitt</button>
                </div>
            </div>
        </div>
    </div>

{% endblock %}
{% block jquery %}
{{ super() }}
<script src="/static/bower_components/moment/min/moment.min.js"></script>
<script src="/static/bower_components/datatables.net/js/jquery.dataTables.min.js"></script>
<script src="/static/bower_components/datatables.net-bs/js/dataTables.bootstrap.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.6.0/Chart.js"></script>
<script>
    // set default to straight lines - no curves
    // Chart.defaults.global.elements.line.tension = 0;
    // set default no fill beneath the line
    Chart.defaults.global.elements.line.fill = false;

    var barChartData = {
      labels: [{% for item in mijia_sensor_data %}
                  moment("{{ item.timestamp.strftime('%Y-%m-%dT%H:%M:%SZ') }}").format('YYYY-MM-DD HH:mm'),
              {% endfor %}],
      datasets: [{
        type: 'line',
        label: 'Temperature',
        yAxisID: "y-axis-0",
        borderColor: "rgba(217,83,79,0.75)",
        backgroundColor: "rgba(217,83,79,0.75)",
        data: [{% for item in mijia_sensor_data %}
                      "{{ item.temperature }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Humidity',
        yAxisID: "y-axis-0",
        borderColor: "rgba(92,184,92,0.75)",
        backgroundColor: "rgba(92,184,92,0.75)",
        data: [{% for item in mijia_sensor_data %}
                      "{{ item.humidity }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Battery',
        yAxisID: "y-axis-1",
        borderColor: "rgba(51,51,51,0.5)",
        backgroundColor: "rgba(51,51,51,0.5)",
        data: [{% for item in mijia_sensor_data %}
                      "{{ item.battery }}",
                    {% endfor %}]
      }]
    };

    var ctx = document.getElementById("chart-mijia");
    // allocate and initialize a chart
    var ch = new Chart(ctx, {
      type: 'line',
      data: barChartData,
      options: {
        title: {
          display: false,
          text: "Statistics Mijia Sensor"
        },
        tooltips: {
          mode: 'label'
        },
        responsive: true,
        scales: {
          xAxes: [{
            stacked: true,
            scaleLabel: {
                display: true,
                labelString: 'Timestamp'
            },
            gridLines : {
                display : true
            }
          }],
          yAxes: [{
            stacked: false,
            position: "left",
            id: "y-axis-0",
            scaleLabel: {
                display: true,
                labelString: 'Temperature / Humidity'
            },
            gridLines : {
                display : true
            }
          }, {
            stacked: false,
            position: "right",
            id: "y-axis-1",
            scaleLabel: {
                display: true,
                labelString: 'Battery'
            },
            gridLines : {
                display : true
            }
          }]
        }
      }
    });

</script>
<script>
    // set default to straight lines - no curves
    // Chart.defaults.global.elements.line.tension = 0;
    // set default no fill beneath the line
    Chart.defaults.global.elements.line.fill = false;

    var barChartData = {
      labels: [{% for item in flora_sensor_data %}
                  moment("{{ item.timestamp.strftime('%Y-%m-%dT%H:%M:%SZ') }}").format('YYYY-MM-DD HH:mm'),
              {% endfor %}],
      datasets: [{
        type: 'line',
        label: 'Temperature',
        yAxisID: "y-axis-0",
        borderColor: "rgba(217,83,79,0.75)",
        backgroundColor: "rgba(217,83,79,0.75)",
        data: [{% for item in flora_sensor_data %}
                      "{{ item.temperature }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Moisture',
        yAxisID: "y-axis-0",
        borderColor: "rgba(92,184,92,0.75)",
        backgroundColor: "rgba(92,184,92,0.75)",
        data: [{% for item in flora_sensor_data %}
                      "{{ item.moisture }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Light',
        yAxisID: "y-axis-0",
        borderColor: "rgba(255, 204, 0, 0.54)",
        backgroundColor: "rgba(255, 204, 0, 0.54)",
        data: [{% for item in flora_sensor_data %}
                      "{{ item.light }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Conductivity',
        yAxisID: "y-axis-1",
        borderColor: "rgba(0, 76, 255, 0.66)",
        backgroundColor: "rgba(0, 76, 255, 0.66)",
        data: [{% for item in flora_sensor_data %}
                      "{{ item.conductivity }}",
                    {% endfor %}]
      }, {
        type: 'line',
        label: 'Battery',
        yAxisID: "y-axis-1",
        borderColor: "rgba(51,51,51,0.5)",
        backgroundColor: "rgba(51,51,51,0.5)",
        data: [{% for item in flora_sensor_data %}
                      "{{ item.battery }}",
                    {% endfor %}]
      }]
    };

    var ctx = document.getElementById("chart-flora");
    // allocate and initialize a chart
    var ch = new Chart(ctx, {
      type: 'line',
      data: barChartData,
      options: {
        title: {
          display: false,
          text: "Statistics Flora Sensor"
        },
        tooltips: {
          mode: 'label'
        },
        responsive: true,
        scales: {
          xAxes: [{
            stacked: true,
            scaleLabel: {
                display: true,
                labelString: 'Timestamp'
            },
            gridLines : {
                display : true
            }
          }],
          yAxes: [{
            stacked: false,
            position: "left",
            id: "y-axis-0",
            scaleLabel: {
                display: true,
                labelString: 'Temperature / Moisture / Light'
            },
            gridLines : {
                display : true
            }
          }, {
            stacked: false,
            position: "right",
            id: "y-axis-1",
            scaleLabel: {
                display: true,
                labelString: 'Conductivity / Battery'
            },
            gridLines : {
                display : true
            }
          }]
        }
      }
    });

</script>
<script>
    $('#confirm-disable').on('click', '.btn-ok', function(e) {
        var $modalDiv = $(e.delegateTarget);
        var id = $(this).data('recordId');
        var csrf_token = "{{ csrf_token() }}";
        $.ajaxSetup({
          beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type) && !this.crossDomain) {
                xhr.setRequestHeader("X-CSRFToken", csrf_token);
              }
            }
        });
        $.ajax({url: '/sensors/alerts/close/' + id, type: 'POST', success: function(){
            $('[data-record-id=' + id + ']').remove();
            }
        });
        $modalDiv.addClass('loading');
        setTimeout(function() {
            $modalDiv.modal('hide').removeClass('loading');
        }, 1000)
    });
    $('#confirm-disable').on('show.bs.modal', function(e) {
        var data = $(e.relatedTarget).data();
        $('.title', this).text(data.recordTitle);
        $('.btn-ok', this).data('recordId', data.recordId);
    });
</script>

{% endblock %}